###############################################################################
# INITIAL SETUP
###############################################################################

# importing modules
import os 
import numpy
import numpy as np
import datetime
import sys
import subprocess
import pandas as pd
import matplotlib.pyplot as plt
from matplotlib.ticker import MultipleLocator 
#import urllib.request
import urllib
import urllib2
from bs4 import BeautifulSoup


# changing directory 
# dir_work = '/home/pat/Dropbox/COURSES/ATMS411_611_COURSE/PythonSkewTgraphingGettingProgram/Sounding'
dir_work = 'C:\Users\student\Documents\TravisWindle\SoundingAnalysis\BarrowRawData'
os.chdir(dir_work)
sys.path.append(os.path.join(dir_work,'function_directory'))

# importing the functions for reading the data and for datetime arrays
from read_data_function import read_data
#from decompose_datetime_array import decompose_datetime_array


###############################################################################
# SETUP FOR FILE DOWNLOAD 
###############################################################################

# defining the base for the dowload URL
# sample http://weather.uwyo.edu/cgi-bin/sounding?region=naconf&TYPE=TEXT%3ALIST&YEAR=2018&MONTH=04&FROM=1112&TO=1112&STNM=72489
base_url = 'http://weather.uwyo.edu/cgi-bin/sounding?region=naconf&TYPE=TEXT%3ALIST'

# defining a datetime object range
datetime_start = datetime.datetime(2004, 12, 07, 00, 00, 00)
datetime_end = datetime.datetime(2019, 1, 31, 00, 00, 00)

# defining the number of hours or days
# n_hrs = (datetime_end - datetime_start).days*24 + 1
n_days = (datetime_end - datetime_start).days + 1 

# defining station names and main loop
station1 = '70026' # Barrow Alaska.
station_list = [station1]
station_name_list = ['Barrow']
n_stations = len(station_list)
hh_variable = ['00', '12'] # 00Z and 12Z
n_hh_variables = len(hh_variable)


###############################################################################
# MAIN FILES DOWNLOAD LOOP | ALL SOUNDINGS GOING INTO ONE FOLDER
###############################################################################

# creating soundings directory 
dir_soundings = os.path.join(dir_work, str('soundings'))     
if not os.path.isdir(dir_soundings):
    os.mkdir(dir_soundings)
else:
    print('%s directory already exists' % dir_soundings)

for station in range(0, n_stations, 1):  

    for d in range (0, n_days, 1):
        datetime_file = datetime_start + datetime.timedelta(days=d)  
        yy_str = str(datetime_file.year)
        mm_str = str(datetime_file.month)
        dd_str = str(datetime_file.day)
        
        # next step        
        for hh in range (0, n_hh_variables, 1):
            hh_str = str(hh_variable[hh])
            
            # define local file name
            file_name = '%s-%s-%s-%s_%s%s' %(station_list[station], yy_str, mm_str.rjust(2,'0'), dd_str.rjust(2,'0'), hh_variable[hh],'Z') + '.txt'           
            url = base_url + '&YEAR=' + yy_str + '&MONTH=' + mm_str + '&FROM=' + dd_str+hh_str + '&TO=' + dd_str+hh_str + '&STNM=' + station_list[station]
	    print(url)
               
            file_name_local = os.path.join(dir_soundings, file_name)
    
            # check if file exists locally
            if (os.path.isfile(file_name_local)):
                print ('files from %s/%s/%s already exist' % (mm_str, dd_str, yy_str))
            else:
                #urllib.request.urlretrieve(url, file_name_local)
                #urllib.urlretrieve(url, file_name_local)
                #urllib2.Request(url, file_name_local)
                gotit = True
                while gotit:
                    try:
                        content = urllib2.urlopen(url).read()
                    except NameError:
                        time.sleep(1)
                        gotit = True
                        print("Server Error Trying Again")
                    else:
                        gotit = False
                # 2)
                # Remove the html tags
                soup = BeautifulSoup(content, features="html.parser")
                data_text = soup.get_text()

                # 3)
                # Split the content by new line.
                splitted = data_text.split("\n",data_text.count("\n"))

                # 4)
                # Write this splitted text to a .txt document
                #Sounding_filename = str(stn)+'.'+str(year)+str(month)+str(day)+str(hour)+'.txt'
                #f = open(Sounding_filename,'w')
                f = open(file_name_local,'w')
                for line in splitted[4:]:
                    f.write(line+'\n')
                f.close()

                # 5)
                #sounding = SkewT.Sounding(filename=file_name_local)
                #sounding.plot_skewt()
